﻿'Access DB Step 3

'This form has all the features described in my video series.
'We have a confirm on delete, statusbar messages, custom grid colors, and a combo box for the State field.
'It shows how to create a property to manage the update state of the grid and several helper funtions/subs.

'Updated 8/7/2010


Public Class frmStep3

#Region "Properties"
    '---property to hold the boolean value of whether the grid has saved data
    Dim _dbUpdateState As Boolean = False
    Private Property DBUpdateState() As Boolean
        Get
            Return _dbUpdateState
        End Get
        Set(ByVal value As Boolean)
            _dbUpdateState = value
        End Set
    End Property
#End Region

    Private Sub frmStep3_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        GetAllRecords()
    End Sub

    Private Sub btnGetAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetAll.Click
        GetAllRecords()
    End Sub


    Private Sub GetAllRecords()
        Me.CustomersTableAdapter.Fill(Me._customers_03DataSet.Customers)
    End Sub


    Private Sub CustomersBindingNavigatorSaveItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CustomersBindingNavigatorSaveItem.Click
        UpdateDB()
    End Sub


#Region "Mouse click on the grid to turn off statusbar msg"
    Private Sub CustomersDataGridView_MouseClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles CustomersDataGridView.MouseClick
        DBUpdateState = False
        HandleStatusBar()
    End Sub
#End Region

#Region "Confirm delete"
    Private Sub BindingNavigatorDeleteItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BindingNavigatorDeleteItem.Click
        '---confirm delete
        '*****To make this work, set the DeleteItem property of the BindingNavigator to none*****


        '---get the first and last name in the current record selected
        Dim firstName2Delete As String = CustomersDataGridView.CurrentRow.Cells(2).Value.ToString
        Dim lastName2Delete As String = CustomersDataGridView.CurrentRow.Cells(1).Value.ToString
        Dim fullName = String.Concat(firstName2Delete, " ", lastName2Delete)

        '---this gets the value of the first cell (custID in this case)
        Dim custID As String = CustomersDataGridView.CurrentCell.Value.ToString

        Try
            If (MessageBox.Show("Are you sure you want to delete " & fullName & "?", "Please Confirm delete", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)) = Windows.Forms.DialogResult.Yes Then
                If CustomersBindingSource.Count > 0 Then             'make sure there are records in the dataset
                    CustomersBindingSource.RemoveCurrent()          'removes the selected item in the list of records
                    UpdateDB()                                                       'save changes and refresh the grid
                End If

            End If

        Catch ex As Exception
            MessageBox.Show("An error occurred while deleting this record. " & ex.Message, "Mr. Grid Error", _
                            MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try
    End Sub
#End Region


#Region "Set StatusStrip Msg"
    Private Sub HandleStatusBar()
        If DBUpdateState Then
            lblStatus.Text = "Your database has been updated"
        Else
            lblStatus.Text = String.Empty
        End If
    End Sub
#End Region

#Region "Update DB"
    Private Sub UpdateDB()
        '---tell the binding source we are done editing
        Me.CustomersBindingSource.EndEdit()
        Try
            '---update everything in DB
            Me.CustomersTableAdapter.Update(Me._customers_03DataSet.Customers)
            'MessageBox.Show("Your database has been updated")

            DBUpdateState = True
            HandleStatusBar()
        Catch ex As Exception
            MessageBox.Show("An error occurred while updating this record. " & ex.Message, "Mr. Grid Error", _
                           MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
#End Region


    Private Sub btnFindExact_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFindExact.Click

        Dim name2Find As String = txtFindExact.Text.Trim
        CustomersTableAdapter.FillByLastName(_customers_03DataSet.Customers, name2Find)

    End Sub


    Private Sub btnFindPartial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFindPartial.Click
        Dim name2Find As String = txtFindPartial.Text.Trim
        CustomersTableAdapter.FillByLast(_customers_03DataSet.Customers, name2Find)
    End Sub






End Class